// ----------------------------------------------------------------------
// 06-05-2008
// ----------------------------------------------------------------------
// NOTES: 5 functions part of an openGL project (900 times faster than RQ)
// ----------------------------------------------------------------------
// COMPILE ME WITH FbToRqInc                 Menu Compile/Gcc to Inc ...
// ----------------------------------------------------------------------
// ----------------------------------------------------------------------
   long __stdcall GCC_ZeroArray (unsigned char *ptrA, long b, long c, long d) {
        long x, y, iTmp;
        for (y = 0 ; y < 1024 ; y++) {
            iTmp = y << 10;
            for (x = 0 ; x < 1024 ; x++) {
                 ptrA[iTmp + x] = 0;
            }
        }
        return (long)ptrA;
   }
// ----------------------------------------------------------------------
// ----------------------------------------------------------------------
   long __stdcall GCC_InitRQArray (unsigned char *ptrA, long b, long c, long d) {
        long x, y, iTmp;
        unsigned char bChar;
        for (y = 0 ; y < 1024 ; y++) {
        iTmp = y << 10;
            for (x = 0 ; x < 1024 ; x++) {
                 bChar = (unsigned char)((y + x) & 0xFF);
                 ptrA[iTmp + x] = bChar;
            }
        }
        return (long)ptrA;
   }
// ---------------------------
/*
Function FB_InitRQArray (ptrA As ubyte ptr, i2 as integer, i3 as integer, i4 as integer) As uByte ptr
    	Dim As Integer x = 0, y = 0, iTmp
    	Dim As Byte bTmp
    	For y = 0 To 1023
          iTmp = y shl 10
    		For x = 0 To 1023
       	    	bTmp = (y + x) & &HFF
			ptrA [iTmp + x] = bTmp
	    	Next x
     Next y
     Return ptrA    ' debug
End Function
*/
// ----------------------------------------------------------------------
// ----------------------------------------------------------------------
   long __stdcall GCC_MoveSeaLevel (unsigned char *ptrW, unsigned char *ptrA,
                                              unsigned char *ptrNDM, long d) {
        long x, y, iTmp, iPos;
        unsigned char bChar;
        for (y = 0 ; y < 1024 ; y++) {
        iTmp = y << 10;
        	  for (x = 0 ; x < 1024 ; x++) {
              	  iPos = iTmp + x;
                 if (ptrA[iPos] > ptrNDM[0])
			       ptrW[iPos] = 255;
                 else
			       ptrW[iPos] = 0;
            }
        }
        return (long)ptrW;
   }
// ---------------------------

/*
Function FB_MoveSeaLevel (ptrW As ubyte ptr, ptrA As uByte ptr, ptrNDM As ubyte ptr, i4 as integer) As uByte Ptr
    	Dim As Integer x = 0, y = 0, iPos = 0, iTmp = 0
  	For y = 0 To 1023        ' y then x for speed
          iTmp = y shl 10
	     For x = 0 To 1023   
             	iPos = iTmp + x
               IF ptrA[iPos] > ptrNDM[0] THEN
			 	ptrW[iPos] = 255
			Else
         			ptrW[iPos] = 0
               End If
	    	Next x
     Next y
     Return ptrW   ' Debug
End Function
' SUB MoveSeaLevel
'     NDM=SeaLevel
'     FOR X = 0 TO 1023
'     FOR Y = 0 TO 1023
'     W?(X, Y) = 0: IF A?(X, Y) > NDM THEN W?(X, Y) = 255
'     NEXT Y: NEXT X
' END SUB
*/
// ----------------------------------------------------------------------
// ----------------------------------------------------------------------
   long __stdcall GCC_InvertHeightMap (short *ptrZ, unsigned char *ptrA, unsigned char *ptrW, unsigned char *ptrNDM) {
        long x, y, iTmp, iPos;
        unsigned char bChar;
        for (y = 0 ; y < 1024 ; y++) {
            iTmp = y << 10;
        	  for (x = 0 ; x < 1024 ; x++) {
              	  iPos = iTmp + x;
                 ptrZ[iPos] = 1023 - ptrZ[iPos];
                 ptrA[iPos] = ptrZ[iPos]/4;
                 if (ptrA[iPos] > ptrNDM[0])
			       ptrW[iPos] = 255;
                 else
			       ptrW[iPos] = 0;
            }
        }
        return (long) ptrZ;
   }
// -----------------------
/*
Function FB_InvertHeightMap (ptrZ As uShort Ptr, ptrA as uByte Ptr, ptrW as uByte Ptr, ptrNDM as uByte Ptr) As uShort Ptr
   	Dim As Integer x = 0, y = 0, iPos = 0, iTmp = 0
  	For y = 0 To 1023        ' y then x for speed
          iTmp = y shl 10
	     For x = 0 To 1023   
             	iPos = iTmp + x
               ptrZ[iPos] = 1023 - ptrZ[iPos]
               ptrA[iPos] = ptrZ[iPos] shr 2     ' shr 2  is /4   much faster
         		IF ptrA[iPos] > ptrNDM[0] THEN
			 	ptrW[iPos] = 255
			Else
         			ptrW[iPos] = 0
               End If
	    	Next x
     Next y
     Return ptrZ   ' Debug
End Function
'
' SUB InvertHeightMap
'     FOR X = 0 TO 1023
'     FOR Y = 0 TO 1023
'     Z%(X, Y) = 1023 - Z%(X, Y)
'     A?(X, Y) = Z%(X, Y)\4
'     W?(X, Y) = 0: IF A?(X, Y) > NDM THEN W?(X, Y) = 255
'     NEXT Y: NEXT X
' END SUB
*/
// -----------------------------------------------------------------------
// -----------------------------------------------------------------------
   long __stdcall GCC_SwapRows (unsigned char *ptrA, long b, long c, long d) {
        long x, y, iTmp, iPos1, iPos2;
        unsigned char bChar;
        for (y = 0 ; y < 1024 ; y++) {
            iTmp = y << 10;
        	  for (x = 0 ; x < 512 ; x++) {
              	  iPos1 = iTmp + x;
                 iPos2 = iTmp + 1023 - x;
                 bChar = ptrA[iPos1];
                 ptrA[iPos1] = ptrA[iPos2];
                 ptrA[iPos2] = bChar;
                 // Swap ptrA[iPos1], ptrA[iPos2];
            }
        }
        return (long) ptrA;
   }

// -----------------------
/*
Function FB_SwapRows (ptrA As uByte ptr, i2 as integer, i3 as integer, i4 as integer) As uByte Ptr
    	Dim As Integer x = 0, y = 0, iPos1 = 0, iPos2 = 0, iTmp = 0
     Dim As Byte  bTmp
  	For y = 0 To 1023        ' y then x for speed
          iTmp = y shl 10
	     For x = 0 To 511
             	iPos1 = iTmp + x
               iPos2 = iTmp + 1023 - x
               bTmp = ptrA[iPos1]
               ptrA[iPos1] = ptrA[iPos2]
               ptrA[iPos2] = bTmp
               ' Swap ptrA[iPos1], ptrA[iPos2]
	    	Next x
     Next y
     Return ptrA     ' Debug
End Function
'
' SUB SwapRows
'     DIM TEMP?
'     FOR X = 0 TO 511
'     FOR Y = 0 TO 1023
'         TEMP?   = A?(X,Y)
'         A?(X,Y) = A?(1023-X,Y)
'         A?(1023-X,Y) = TEMP?
'     NEXT Y:NEXT X
' END SUB
*/
// ----------------------------------------------------------------------


